/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Apr 6, 2005
 *
 */
package com.sunlabs.archsim.tests.merge;

import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.Function;

/**
 * @author ib27688
 *
 */
public class MergeTestSource extends Action {
	
	protected int index;
	
	public MergeTestSource(String name, int ind, int start) {
		super(name);
		index=ind;
		outputFunctions.put(MergeTestGlobal.SRC_OUT+MergeTestGlobal.DELIMITER+index, 
				new GenerateData(start));
	} // FifoAction
	
	/** Generate new data items */
	private class GenerateData extends Function {

		private int next;
		
		public GenerateData(int start) {
			super("GenerateData");
			next= start;
			functionDelay= MergeTestGlobal.SOURCE_DELAY;
		}
		
		public Object value() {
			if (MergeTestGlobal.sourceDisplayGenerated) {
				director.journal("Source " + MergeTestSource.this.getName() 
						+ " generated " + next);
			}
			return new Integer(next++);	
		} // value
	} // PassData

}
