package edu.berkeley.sbp;
import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;

/** currently this class exports only static methods to create repetitions; there are no public instance methods or constructors */
class Repeat extends Union {

    Repeat(final Element e, boolean zeroOkay, boolean manyOkay, final Element separator, boolean maximal) {
        this(e, zeroOkay, manyOkay, separator, maximal, null); }
    Repeat(final Element e, boolean zeroOkay, boolean manyOkay, final Element separator, boolean maximal, Object tag) {
        super(e+(!manyOkay ? "?" : (zeroOkay ? (maximal ? "**" : "*") : (maximal ? "++" : "+")))+(separator==null?"":("/"+separator)), true);
        if (maximal && zeroOkay && separator != null)
            throw new RuntimeException("cannot create a maximal repetition of zero or more items with a separator (yet): " + this);
        if (zeroOkay) {
            add(new Sequence.Constant.Empty());
            if (manyOkay) add(new Sequence.Singleton(Sequence.many1(e, separator)));
            else          add(new Sequence.Singleton(e));
        } else {
            add(new Sequence.RewritingSequence(tag, new Element[] { e }, null));
            if (separator==null)
                add(new Sequence.Unwrap(new Element[] { e,                 Repeat.this }, tag));
            else
                add(new Sequence.Unwrap(new Element[] { e, separator,      Repeat.this }, tag, new boolean[] { false, true, false }));
        }
        if (maximal) for(Sequence s : this) s.noFollow = separator==null ? e : separator;
    }
}
